import { BaseComponentProps } from '@aws-amplify/ui-react';
import { ComponentMetadata, StudioComponent, StudioComponentChild, StudioNode } from '@aws-amplify/codegen-ui';
import { JsxChild, JsxElement } from 'typescript';
import { ReactComponentRenderer } from '../react-component-renderer';
import { ImportCollection } from '../imports';
import { ReactRenderConfig } from '../react-render-config';
import { defaultRenderConfig } from '../react-studio-template-renderer-helper';
export default class CollectionRenderer extends ReactComponentRenderer<BaseComponentProps> {
    protected componentMetadata: ComponentMetadata;
    protected importCollection: ImportCollection;
    protected renderConfig: ReactRenderConfig & typeof defaultRenderConfig;
    protected parent?: StudioNode | undefined;
    constructor(component: StudioComponent | StudioComponentChild, componentMetadata: ComponentMetadata, importCollection: ImportCollection, renderConfig: ReactRenderConfig & typeof defaultRenderConfig, parent?: StudioNode | undefined);
    renderElement(renderChildren: (children: StudioComponentChild[]) => JsxChild[]): JsxElement;
    private renderCollectionOpeningElement;
    private addKeyPropertyToChildren;
    private findItemsVariableName;
    private renderItemArrowFunctionExpr;
    private getCollectionElement;
}
