export declare enum ImportSource {
    REACT = "react",
    UI_REACT = "@aws-amplify/ui-react",
    UI_REACT_INTERNAL = "@aws-amplify/ui-react/internal",
    AMPLIFY_DATASTORE = "@aws-amplify/datastore",
    REACT_STORAGE = "@aws-amplify/ui-react-storage",
    LOCAL_MODELS = "../models",
    LOCAL_SCHEMA = "../models/schema",
    UTILS = "./utils",
    AMPLIFY = "aws-amplify",
    AMPLIFY_API = "aws-amplify/api",
    AMPLIFY_AUTH = "aws-amplify/auth",
    AMPLIFY_UTILS = "aws-amplify/utils",
    AMPLIFY_DATASTORE_V6 = "aws-amplify/datastore"
}
export declare enum ImportValue {
    GET_OVERRIDE_PROPS = "getOverrideProps",
    USE_AUTH = "useAuth",
    AUTH = "Auth",
    SIGN_OUT = "signOut",
    FETCH_USER_ATTRIBUTES = "fetchUserAttributes",
    GET_OVERRIDES_FROM_VARIANTS = "getOverridesFromVariants",
    USE_BREAKPOINT_VALUE = "useBreakpointValue",
    VARIANT = "Variant",
    SORT_DIRECTION = "SortDirection",
    SORT_PREDICATE = "SortPredicate",
    CREATE_DATA_STORE_PREDICATE = "createDataStorePredicate",
    USE_DATA_STORE_BINDING = "useDataStoreBinding",
    CREATE_THEME = "createTheme",
    MERGE_VARIANTS_OVERRIDES = "mergeVariantsAndOverrides",
    USE_NAVIGATE_ACTION = "useNavigateAction",
    USE_DATA_STORE_CREATE_ACTION = "useDataStoreCreateAction",
    USE_DATA_STORE_UPDATE_ACTION = "useDataStoreUpdateAction",
    USE_DATA_STORE_DELETE_ACTION = "useDataStoreDeleteAction",
    USE_AUTH_SIGN_OUT_ACTION = "useAuthSignOutAction",
    USE_STATE_MUTATION_ACTION = "useStateMutationAction",
    USE_EFFECT = "useEffect",
    VALIDATE_FIELD = "validateField",
    VALIDATE_FIELD_CODEGEN = "validateField",
    FORMATTER = "formatter",
    FETCH_BY_PATH = "fetchByPath",
    PROCESS_FILE = "processFile",
    DEFAULT_THEME = "defaultTheme",
    USE_STATE = "useState",
    API = "API",
    HUB = "Hub",
    DATASTORE = "DataStore",
    PAGINATION = "Pagination",
    PLACEHOLDER = "Placeholder",
    GENERATE_CLIENT = "generateClient"
}
export declare const ImportMapping: Record<ImportValue, ImportSource>;
