import { FrameworkRenderConfig } from '@aws-amplify/codegen-ui';
import { ScriptKind, ScriptTarget, ModuleKind } from 'typescript';
export { ScriptKind, ScriptTarget, ModuleKind } from 'typescript';
export declare type DataApiKind = 'DataStore' | 'GraphQL' | 'NoApi';
export declare type ReactRenderConfig = FrameworkRenderConfig & {
    script?: ScriptKind;
    target?: ScriptTarget;
    module?: ModuleKind;
    renderTypeDeclarations?: boolean;
    inlineSourceMap?: boolean;
    apiConfiguration?: GraphqlRenderConfig | DataStoreRenderConfig | NoApiRenderConfig;
    dependencies?: {
        [key: string]: string;
    };
    includeUseClientDirective?: boolean;
};
export declare type GraphqlRenderConfig = {
    dataApi: 'GraphQL';
    typesFilePath: string | undefined;
    queriesFilePath: string;
    mutationsFilePath: string;
    subscriptionsFilePath: string;
    fragmentsFilePath: string;
};
export declare type DataStoreRenderConfig = {
    dataApi: 'DataStore';
};
export declare type NoApiRenderConfig = {
    dataApi: 'NoApi';
};
export declare function scriptKindToFileExtension(scriptKind: ScriptKind): string;
export declare function scriptKindToFileExtensionNonReact(scriptKind: ScriptKind): string;
