"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOverridePropsString = exports.getOverrideProps = void 0;
const getOverrideProps = (overrides, elementHierarchy) => {
    if (!overrides) {
        return null;
    }
    const componentOverrides = Object.entries(overrides)
        .filter(([key]) => key === elementHierarchy)
        .flatMap(([, value]) => Object.entries(value))
        .filter((m) => m === null || m === void 0 ? void 0 : m[0]);
    return Object.fromEntries(componentOverrides);
};
exports.getOverrideProps = getOverrideProps;
exports.getOverridePropsString = `export const getOverrideProps = (
  overrides: EscapeHatchProps | null | undefined,
  elementHierarchy: string
): EscapeHatchProps | null => {
  if (!overrides) {
    return null;
  }

  const componentOverrides = Object.entries(overrides)
    .filter(([key]) => key === elementHierarchy)
    .flatMap(([, value]) => Object.entries(value))
    .filter((m) => m?.[0]);

  return Object.fromEntries(componentOverrides) as unknown as EscapeHatchProps;
};`;
//# sourceMappingURL=getOverrideProps.js.map