import { StorageManagerProps } from '@aws-amplify/ui-react-storage';
export declare const processFile: ({ file }: Parameters<NonNullable<StorageManagerProps['processFile']>>[0]) => Promise<{
    file: File;
    key: string;
}>;
export declare const processFileString = "export const processFile = async ({ file }) => {\n  const fileExtension = file.name.split('.').pop();\n  return file\n    .arrayBuffer()\n    .then((filebuffer) => window.crypto.subtle.digest(\"SHA-1\", filebuffer))\n    .then((hashBuffer) => {\n      const hashArray = Array.from(new Uint8Array(hashBuffer));\n      const hashHex = hashArray.map((a) => a.toString(16).padStart(2, '0')).join('');\n      return { file, key: `${hashHex}.${fileExtension}` };\n    });\n};";
