export declare const useAuthSignOutActionString = "export const useAuthSignOutAction: UseAuthSignOutAction =\n  (options) => async () => {\n    try {\n      Hub.dispatch(\n        UI_CHANNEL,\n        {\n          event: ACTION_AUTH_SIGNOUT_STARTED,\n          data: { options },\n        },\n        EVENT_ACTION_AUTH_SIGNOUT,\n        AMPLIFY_SYMBOL\n      );\n\n      await Auth.signOut(options);\n      Hub.dispatch(\n        UI_CHANNEL,\n        {\n          event: ACTION_AUTH_SIGNOUT_FINISHED,\n          data: { options },\n        },\n        EVENT_ACTION_AUTH_SIGNOUT,\n        AMPLIFY_SYMBOL\n      );\n    } catch (error) {\n      Hub.dispatch(\n        UI_CHANNEL,\n        {\n          event: ACTION_AUTH_SIGNOUT_FINISHED,\n          data: { options, errorMessage: getErrorMessage(error) },\n        },\n        EVENT_ACTION_AUTH_SIGNOUT,\n        AMPLIFY_SYMBOL\n      );\n    }\n  };";
export declare const useAuthSignOutActionStringV6 = "export const useAuthSignOutAction: UseAuthSignOutAction =\n  (options) => async () => {\n    try {\n      Hub.dispatch(\n        UI_CHANNEL,\n        {\n          event: ACTION_AUTH_SIGNOUT_STARTED,\n          data: { options },\n        },\n        EVENT_ACTION_AUTH_SIGNOUT,\n        AMPLIFY_SYMBOL\n      );\n\n      await signOut(options);\n      Hub.dispatch(\n        UI_CHANNEL,\n        {\n          event: ACTION_AUTH_SIGNOUT_FINISHED,\n          data: { options },\n        },\n        EVENT_ACTION_AUTH_SIGNOUT,\n        AMPLIFY_SYMBOL\n      );\n    } catch (error) {\n      Hub.dispatch(\n        UI_CHANNEL,\n        {\n          event: ACTION_AUTH_SIGNOUT_FINISHED,\n          data: { options, errorMessage: getErrorMessage(error) },\n        },\n        EVENT_ACTION_AUTH_SIGNOUT,\n        AMPLIFY_SYMBOL\n      );\n    }\n  };";
