export declare const useDataStoreCreateActionString = "export const useDataStoreCreateAction = <Model extends PersistentModel>({\n  model,\n  fields: initialFields,\n  schema,\n}: UseDataStoreCreateActionOptions<Model>): (() => Promise<void>) => {\n  const fields = useTypeCastFields<Model>({\n    fields: initialFields,\n    modelName: model.name,\n    schema,\n  });\n\n  return async () => {\n    try {\n      Hub.dispatch(\n        UI_CHANNEL,\n        {\n          event: ACTION_DATASTORE_CREATE_STARTED,\n          data: { fields },\n        },\n        EVENT_ACTION_DATASTORE_CREATE,\n        AMPLIFY_SYMBOL\n      );\n\n      const item = await DataStore.save(new model(fields));\n\n      Hub.dispatch(\n        UI_CHANNEL,\n        {\n          event: ACTION_DATASTORE_CREATE_FINISHED,\n          data: { fields, item },\n        },\n        EVENT_ACTION_DATASTORE_CREATE,\n        AMPLIFY_SYMBOL\n      );\n    } catch (error) {\n      Hub.dispatch(\n        UI_CHANNEL,\n        {\n          event: ACTION_DATASTORE_CREATE_FINISHED,\n          data: {\n            fields,\n            errorMessage: getErrorMessage(error),\n          },\n        },\n        EVENT_ACTION_DATASTORE_CREATE,\n        AMPLIFY_SYMBOL\n      );\n    }\n  };\n};";
